//Titel:            Testbeispiel fuer das Design Pattern Singleton
//Version:          05.05.2013
//Copyright:        HS-Harz, FB AI
//Autor:            Dipl.-Inf.(TU) Dipl.-Ing.(FH) Michael Wilhelm
//Firma:            HS-Harz
//Beschreibung:     Erster Versuch  Singleton zu realisieren

// Design Pattern Singleton
// Stellt sicher, dass nur eine Instanz existiert
// dazu wird der Defautl-Konstrutor als private bzw. protected definiert
// die synchronized-Anweisung stellt die Einzigartigkeit sicher

// Beispiel ohne Ausgabe

import java.io.*;

public class Singleton1a {


  private static void pause() {
    try {
      System.in.read();
    }
    catch (IOException e) {
    }
  }  // pause


  static public void main(String[] args) {
     Singleton a = Singleton.getSingleton();
     a.value=1;
     Singleton b = Singleton.getSingleton();
     b.value=2;
     Singleton c = Singleton.getSingleton();
     c.value=3;

     System.out.println(a.value);
     System.out.println(b.value);
     System.out.println(c.value);
     pause();
   }



}

 class Singleton {
     public int value = 0;
    private static Singleton instance=new Singleton ();

       private Singleton () {
       }

	public static Singleton getSingleton(){
         return instance;
	}
}

